LibFileSet (Apache Ant API)
Description: declaration: package: org.apache.tools.ant.taskdefs.optional.extension, class: LibFileSet

# Class LibFileSet

java.lang.Object
org.apache.tools.ant.ProjectComponent
org.apache.tools.ant.types.DataType
org.apache.tools.ant.types.AbstractFileSet
org.apache.tools.ant.types.FileSet
org.apache.tools.ant.taskdefs.optional.extension.LibFileSet

All Implemented Interfaces:
  `Cloneable, Iterable<Resource>, ResourceCollection, SelectorContainer`

public class LibFileSet extends FileSet
LibFileSet represents a fileset containing libraries. Associated with the libraries is data pertaining to how they are to be handled when building manifests.

- ## Field Summary

  ### Fields inherited from class DataType

  `checked, ref`
  Modifier and Type
  Field
  Description
  `protected boolean`
  `checked`
  Deprecated.
  since 1.7.
  `protected Reference`
  `ref`
  Deprecated.
  since 1.7.

  ### Fields inherited from class ProjectComponent

  `description, location, project`
  Modifier and Type
  Field
  Description
  `protected String`
  `description`
  Deprecated.
  since 1.6.x.
  `protected Location`
  `location`
  Deprecated.
  since 1.6.x.
  `protected Project`
  `project`
  Deprecated.
  since 1.6.x.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `LibFileSet()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `setIncludeImpl(boolean includeImpl)`
  Flag indicating whether should include the "Implementation-*" attributes in manifest.
  `void`
  `setIncludeUrl(boolean includeURL)`
  Flag indicating whether should include the "Implementation-URL" attribute in manifest.
  `void`
  `setUrlBase(String urlBase)`
  Set the url base for fileset.

  ### Methods inherited from class FileSet

  `clone, getRef, isFilesystemOnly, iterator, size`
  Modifier and Type
  Method
  Description
  `Object`
  `clone()`
  Return a FileSet that has the same basedir and same patternsets as this one.
  `protected AbstractFileSet`
  `getRef(Project p)`
  Performs the check for circular references and returns the referenced FileSet.
  `boolean`
  `isFilesystemOnly()`
  Always returns true.
  `Iterator<Resource>`
  `iterator()`
  Fulfill the ResourceCollection contract.
  `int`
  `size()`
  Fulfill the ResourceCollection contract.

  ### Methods inherited from class AbstractFileSet

  `add, addAnd, addContains, addContainsRegexp, addCustom, addDate, addDepend, addDepth, addDifferent, addExecutable, addFilename, addMajority, addModified, addNone, addNot, addOr, addOwnedBy, addPosixGroup, addPosixPermissions, addPresent, addReadable, addSelector, addSize, addSymlink, addType, addWindowsJunction, addWritable, appendExcludes, appendIncludes, appendSelector, createExclude, createExcludesFile, createInclude, createIncludesFile, createPatternSet, dieOnCircularReference, getDefaultexcludes, getDir, getDir, getDirectoryScanner, getDirectoryScanner, getErrorOnMissingDir, getMaxLevelsOfSymlinks, getSelectors, hasPatterns, hasSelectors, isCaseSensitive, isFollowSymlinks, mergeExcludes, mergeIncludes, mergePatterns, selectorCount, selectorElements, setCaseSensitive, setDefaultexcludes, setDir, setErrorOnMissingDir, setExcludes, setExcludesfile, setFile, setFollowSymlinks, setIncludes, setIncludesfile, setMaxLevelsOfSymlinks, setRefid, setupDirectoryScanner, setupDirectoryScanner, toString`
  Modifier and Type
  Method
  Description
  `void`
  `add(FileSelector selector)`
  Add an arbitrary selector.
  `void`
  `addAnd(AndSelector selector)`
  Add an "And" selector entry on the selector list.
  `void`
  `addContains(ContainsSelector selector)`
  Add a contains selector entry on the selector list.
  `void`
  `addContainsRegexp(ContainsRegexpSelector selector)`
  Add a regular expression selector entry on the selector list.
  `void`
  `addCustom(ExtendSelector selector)`
  Add an extended selector entry on the selector list.
  `void`
  `addDate(DateSelector selector)`
  Add a selector date entry on the selector list.
  `void`
  `addDepend(DependSelector selector)`
  Add a depends selector entry on the selector list.
  `void`
  `addDepth(DepthSelector selector)`
  Add a depth selector entry on the selector list.
  `void`
  `addDifferent(DifferentSelector selector)`
  Add a DifferentSelector entry on the selector list.
  `void`
  `addExecutable(ExecutableSelector e)`
  `void`
  `addFilename(FilenameSelector selector)`
  Add a selector filename entry on the selector list.
  `void`
  `addMajority(MajoritySelector selector)`
  Add a majority selector entry on the selector list.
  `void`
  `addModified(ModifiedSelector selector)`
  Add the modified selector.
  `void`
  `addNone(NoneSelector selector)`
  Add a "None" selector entry on the selector list.
  `void`
  `addNot(NotSelector selector)`
  Add a "Not" selector entry on the selector list.
  `void`
  `addOr(OrSelector selector)`
  Add an "Or" selector entry on the selector list.
  `void`
  `addOwnedBy(OwnedBySelector o)`
  `void`
  `addPosixGroup(PosixGroupSelector o)`
  `void`
  `addPosixPermissions(PosixPermissionsSelector o)`
  `void`
  `addPresent(PresentSelector selector)`
  Add a present selector entry on the selector list.
  `void`
  `addReadable(ReadableSelector r)`
  `void`
  `addSelector(SelectSelector selector)`
  Add a "Select" selector entry on the selector list.
  `void`
  `addSize(SizeSelector selector)`
  Add a selector size entry on the selector list.
  `void`
  `addSymlink(SymlinkSelector e)`
  `void`
  `addType(TypeSelector selector)`
  Add a selector type entry on the selector list.
  `void`
  `addWindowsJunction(WindowsJunctionSelector e)`
  `void`
  `addWritable(WritableSelector w)`
  `void`
  `appendExcludes(String[] excludes)`
  Appends `excludes` to the current list of exclude patterns.
  `void`
  `appendIncludes(String[] includes)`
  Appends `includes` to the current list of include patterns.
  `void`
  `appendSelector(FileSelector selector)`
  Add a new selector into this container.
  `PatternSet.NameEntry`
  `createExclude()`
  Add a name entry to the exclude list.
  `PatternSet.NameEntry`
  `createExcludesFile()`
  Add a name entry to the excludes files list.
  `PatternSet.NameEntry`
  `createInclude()`
  Add a name entry to the include list.
  `PatternSet.NameEntry`
  `createIncludesFile()`
  Add a name entry to the include files list.
  `PatternSet`
  `createPatternSet()`
  Creates a nested patternset.
  `protected void`
  `dieOnCircularReference(Stack<Object> stk, Project p)`
  Check to see whether any DataType we hold references to is included in the Stack (which holds all DataType instances that directly or indirectly reference this instance, including this instance itself).
  `boolean`
  `getDefaultexcludes()`
  Whether default exclusions should be used or not.
  `File`
  `getDir()`
  Retrieves the base-directory for this instance.
  `File`
  `getDir(Project p)`
  Retrieves the base-directory for this instance.
  `DirectoryScanner`
  `getDirectoryScanner()`
  Returns the directory scanner needed to access the files to process.
  `DirectoryScanner`
  `getDirectoryScanner(Project p)`
  Returns the directory scanner needed to access the files to process.
  `boolean`
  `getErrorOnMissingDir()`
  Gets whether an error is/should be thrown if the base directory does not exist.
  `int`
  `getMaxLevelsOfSymlinks()`
  The maximum number of times a symbolic link or Windows junctions may be followed during a scan.
  `FileSelector[]`
  `getSelectors(Project p)`
  Returns the set of selectors as an array.
  `boolean`
  `hasPatterns()`
  Indicates whether there are any patterns here.
  `boolean`
  `hasSelectors()`
  Indicates whether there are any selectors here.
  `boolean`
  `isCaseSensitive()`
  Find out if the fileset is case sensitive.
  `boolean`
  `isFollowSymlinks()`
  Find out if the fileset wants to follow symbolic links or Windows junctions.
  `String[]`
  `mergeExcludes(Project p)`
  Get the merged exclude patterns for this AbstractFileSet.
  `String[]`
  `mergeIncludes(Project p)`
  Get the merged include patterns for this AbstractFileSet.
  `PatternSet`
  `mergePatterns(Project p)`
  Get the merged patterns for this AbstractFileSet.
  `int`
  `selectorCount()`
  Gives the count of the number of selectors in this container.
  `Enumeration<FileSelector>`
  `selectorElements()`
  Returns an enumerator for accessing the set of selectors.
  `void`
  `setCaseSensitive(boolean caseSensitive)`
  Sets case sensitivity of the file system.
  `void`
  `setDefaultexcludes(boolean useDefaultExcludes)`
  Sets whether default exclusions should be used or not.
  `void`
  `setDir(File dir)`
  Sets the base-directory for this instance.
  `void`
  `setErrorOnMissingDir(boolean errorOnMissingDir)`
  Sets whether an error is thrown if a directory does not exist.
  `void`
  `setExcludes(String excludes)`
  Appends `excludes` to the current list of exclude patterns.
  `void`
  `setExcludesfile(File excl)`
  Sets the `File` containing the excludes patterns.
  `void`
  `setFile(File file)`
  Creates a single file fileset.
  `void`
  `setFollowSymlinks(boolean followSymlinks)`
  Sets whether or not symbolic links or Windows junctions should be followed.
  `void`
  `setIncludes(String includes)`
  Appends `includes` to the current list of include patterns.
  `void`
  `setIncludesfile(File incl)`
  Sets the `File` containing the includes patterns.
  `void`
  `setMaxLevelsOfSymlinks(int max)`
  The maximum number of times a symbolic link or Windows junctions may be followed during a scan.
  `void`
  `setRefid(Reference r)`
  Makes this instance in effect a reference to another instance.
  `void`
  `setupDirectoryScanner(FileScanner ds)`
  Set up the specified directory scanner against this AbstractFileSet's Project.
  `void`
  `setupDirectoryScanner(FileScanner ds, Project p)`
  Set up the specified directory scanner against the specified project.
  `String`
  `toString()`
  Returns included files as a list of semicolon-separated filenames.

  ### Methods inherited from class DataType

  `checkAttributesAllowed, checkChildrenAllowed, circularReference, dieOnCircularReference, dieOnCircularReference, getCheckedRef, getCheckedRef, getCheckedRef, getCheckedRef, getCheckedRef, getDataTypeName, getRefid, invokeCircularReferenceCheck, isChecked, isReference, noChildrenAllowed, pushAndInvokeCircularReferenceCheck, setChecked, tooManyAttributes`
  Modifier and Type
  Method
  Description
  `protected void`
  `checkAttributesAllowed()`
  check that it is ok to set attributes, i.e that no reference is defined
  `protected void`
  `checkChildrenAllowed()`
  check that it is ok to add children, i.e that no reference is defined
  `protected BuildException`
  `circularReference()`
  Creates an exception that indicates the user has generated a loop of data types referencing each other.
  `protected void`
  `dieOnCircularReference()`
  Convenience method.
  `protected void`
  `dieOnCircularReference(Project p)`
  Convenience method.
  `protected <T> T`
  `getCheckedRef()`
  Deprecated.
  use getCheckedRef(Class)
  `protected <T> T`
  `getCheckedRef(Class<T> requiredClass)`
  Performs the check for circular references and returns the referenced object.
  `protected <T> T`
  `getCheckedRef(Class<T> requiredClass, String dataTypeName)`
  Performs the check for circular references and returns the referenced object.
  `protected <T> T`
  `getCheckedRef(Class<T> requiredClass, String dataTypeName, Project project)`
  Performs the check for circular references and returns the referenced object.
  `protected <T> T`
  `getCheckedRef(Project p)`
  Deprecated.
  use getCheckedRef(Class)
  `protected String`
  `getDataTypeName()`
  Gets as descriptive as possible a name used for this datatype instance.
  `Reference`
  `getRefid()`
  get the reference set on this object
  `static void`
  `invokeCircularReferenceCheck(DataType dt, Stack<Object> stk, Project p)`
  Allow DataTypes outside org.apache.tools.ant.types to indirectly call dieOnCircularReference on nested DataTypes.
  `protected boolean`
  `isChecked()`
  The flag that is used to indicate that circular references have been checked.
  `boolean`
  `isReference()`
  Has the refid attribute of this element been set?
  `protected BuildException`
  `noChildrenAllowed()`
  Creates an exception that indicates that this XML element must not have child elements if the refid attribute is set.
  `static void`
  `pushAndInvokeCircularReferenceCheck(DataType dt, Stack<Object> stk, Project p)`
  Allow DataTypes outside org.apache.tools.ant.types to indirectly call dieOnCircularReference on nested DataTypes.
  `protected void`
  `setChecked(boolean checked)`
  Set the flag that is used to indicate that circular references have been checked.
  `protected BuildException`
  `tooManyAttributes()`
  Creates an exception that indicates that refid has to be the only attribute if it is set.

  ### Methods inherited from class ProjectComponent

  `getDescription, getLocation, getProject, log, log, setDescription, setLocation, setProject`
  Modifier and Type
  Method
  Description
  `String`
  `getDescription()`
  Returns the description of the current action.
  `Location`
  `getLocation()`
  Returns the file/location where this task was defined.
  `Project`
  `getProject()`
  Returns the project to which this component belongs.
  `void`
  `log(String msg)`
  Logs a message with the default (INFO) priority.
  `void`
  `log(String msg, int msgLevel)`
  Logs a message with the given priority.
  `void`
  `setDescription(String desc)`
  Sets a description of the current action.
  `void`
  `setLocation(Location location)`
  Sets the file/location where this task was defined.
  `void`
  `setProject(Project project)`
  Sets the project object of this component.

  ### Methods inherited from class Object

  `equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface Iterable

  `forEach, spliterator`

  ### Methods inherited from interface ResourceCollection

  `isEmpty, stream`
  Modifier and Type
  Method
  Description
  `default boolean`
  `isEmpty()`
  Learn whether this `ResourceCollection` is empty.
  `default Stream<? extends Resource>`
  `stream()`
  Return a `Stream` over this `ResourceCollection`.

- ## Constructor Details

  - ### LibFileSet

    public LibFileSet()

- ## Method Details

  - ### setIncludeUrl

    public void setIncludeUrl(boolean includeURL)
    Flag indicating whether should include the "Implementation-URL" attribute in manifest. Defaults to false.
    Parameters:
      `includeURL` - the flag

  - ### setIncludeImpl

    public void setIncludeImpl(boolean includeImpl)
    Flag indicating whether should include the "Implementation-*" attributes in manifest. Defaults to false.
    Parameters:
      `includeImpl` - the flag

  - ### setUrlBase

    public void setUrlBase(String urlBase)
    Set the url base for fileset.
    Parameters:
      `urlBase` - the base url